#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <math.h>
#include "head.h"

int del_char( str )
	char *str ;
{
	while( *str != '\0' )
		if ( *str=='\n' || *str=='\r' || *str==' ' || *str=='\t' ) {
			*str = '\0' ;
			return 0 ;
		} else
			str++ ;

	return 0 ;
}

int get_dp( pps, fn )
	PARAMS *pps ;
	char *fn ;
{
	FILE *fp = fopen( fn, "r" ) ;

	if ( fp==NULL )
		return -1 ;
	else {
		int i, j ;
		char str[STR_LEN] ;

		pps->dp = (double *)NULL ;
		pps->ngrp = 0 ;
		while( fgets( str, STR_LEN, fp ) != NULL )
			if ( !isdigit(str[0]) )
				continue ;
			else if ( ( pps->dp = (double *)realloc( pps->dp,
				++pps->ngrp*sizeof *pps->dp ) ) == NULL ) {
				free( pps->dp ) ;
				return -1 ;
			} else
				pps->dp[pps->ngrp-1] = atof( str ) ;

		fclose( fp ) ;
		return pps->ngrp ;
	}
}

int chk_para( fn, pps )
	char **fn ;
	PARAMS *pps ;
{
	FILE *fp ;

	pps->para_file = fn[1] ;
	pps->result_file = fn[2] ;

	if ( (fp=fopen(pps->para_file,"r")) == NULL )
		return -1 ;
	else {
		char str[STR_LEN] ;

		if ( fgets( str, STR_LEN, fp ) == NULL )
			return -1 ;
		else if ( del_char( str ) != 0 )
			return -1 ;
		else if ( get_dp( pps, str ) < 2 )
			return -1 ;

		pps->dx		= atoi( fgets( str, STR_LEN, fp ) ) ;
		pps->dy		= atoi( fgets( str, STR_LEN, fp ) ) ;
		pps->dt		= atoi( fgets( str, STR_LEN, fp ) ) ;

		pps->lt		= atoi( fgets( str, STR_LEN, fp ) ) ;

		pps->sx		= atoi( fgets( str, STR_LEN, fp ) ) ;
		pps->sy		= atoi( fgets( str, STR_LEN, fp ) ) ;
		pps->st		= pps->lt * pps->dt ;

		pps->tintv	= atoi( fgets( str, STR_LEN, fp ) ) ;

		/* read the file name of a correlation map */
		if ( fgets( pps->fnu, STR_LEN, fp ) == NULL )
			return -1 ;
		else if ( del_char( pps->fnu ) != 0 )
			return -1 ;

		/* FHN equations */
		pps->Du		= atof( fgets( str, STR_LEN, fp ) ) ;
		pps->Dv		= atof( fgets( str, STR_LEN, fp ) ) ;

		pps->Cux	= pps->Du * (double)( pps->dx * pps->dx )
						 / (double)pps->dt ;
		pps->Cuy	= pps->Du * (double)( pps->dy * pps->dy )
						 / (double)pps->dt ;
		pps->Cvx	= pps->Dv * (double)( pps->dx * pps->dx )
						 / (double)pps->dt ;
		pps->Cvy	= pps->Dv * (double)( pps->dy * pps->dy )
						 / (double)pps->dt ;

		pps->a0		= atof( fgets( str, STR_LEN, fp ) ) ;
		pps->a1		= atof( fgets( str, STR_LEN, fp ) ) ;
		pps->a2		= atof( fgets( str, STR_LEN, fp ) ) ;
		pps->a3		= atof( fgets( str, STR_LEN, fp ) ) ;

		if ( pps->a1==.0 || pps->a3==.0 ) {
			fprintf( stderr, "a1=%f, a3=%f\n", pps->a1, pps->a3 ) ;
			free( pps->dp ) ;
			return -1 ;
		}

		pps->b		= atof( fgets( str, STR_LEN, fp ) ) ;
		pps->eps	= atof( fgets( str, STR_LEN, fp ) ) ;
		pps->mi		= atof( fgets( str, STR_LEN, fp ) ) ;

		pps->delta_v	= atof( fgets( str, STR_LEN, fp ) ) ;
		pps->phi_v	= atof( fgets( str, STR_LEN, fp ) ) ;

		pps->r		= atof( fgets( str, STR_LEN, fp ) ) ;
		pps->delta	= atof( fgets( str, STR_LEN, fp ) ) ;

		pps->lmin	= atoi( fgets( str, STR_LEN, fp ) ) ;
		pps->lmax	= atoi( fgets( str, STR_LEN, fp ) ) ;

		pps->sw_u	= atoi( fgets( str, STR_LEN, fp ) ) ;
		pps->sw_v	= atoi( fgets( str, STR_LEN, fp ) ) ;

		pps->r0Cux	= pps->r * pps->Cux ;
		pps->r0Cuy	= pps->r * pps->Cuy ;
		pps->r0Cvx	= pps->r * pps->Cvx ;
		pps->r0Cvy	= pps->r * pps->Cvy ;

		pps->r1Cux	= (1.-pps->r) * pps->Cux ;
		pps->r1Cuy	= (1.-pps->r) * pps->Cuy ;
		pps->r1Cvx	= (1.-pps->r) * pps->Cvx ;
		pps->r1Cvy	= (1.-pps->r) * pps->Cvy ;

		fclose( fp ) ;
		return 0 ;
	}
}

int free_mem( ps, ds )
	PARAMS ps ;
	DIMS ds ;
{
	free( ps.dp ) ;

	free( ds.iu ) ;

	free( ds.ou ) ;
	free( ds.nu ) ;
	free( ds.ov ) ;
	free( ds.nv ) ;

	free( ds.dv ) ;

	free( ds.av_dv_x ) ;
	free( ds.av_dv_y ) ;

	free( ds.a ) ;
	free( ds.bij ) ;
	free( ds.max ) ;
	free( ds.adif ) ;

	return 0 ;
}

int all_mem( ps, pds )
	PARAMS ps ;
	DIMS *pds ;
{
	int d = sizeof(double) ;
	int n = ps.ngrp ;
	int sx = ps.sx ;
	int sy = ps.sy ;

	(*pds).iu	= (double ***)an_malloc_3D( sx, sy, n, d ) ;

        (*pds).ou	= (double ***)an_malloc_3D( sx, sy, n, d ) ;
	(*pds).nu	= (double ***)an_malloc_3D( sx, sy, n, d ) ;
	(*pds).ov	= (double ***)an_malloc_3D( sx, sy, n, d ) ;
	(*pds).nv	= (double ***)an_malloc_3D( sx, sy, n, d ) ;

	(*pds).dv	= (double ***)an_malloc_3D( sx, sy, n, d ) ;

	(*pds).av_dv_x	= (double ***)an_malloc_3D( sx, sy, n, d ) ;
	(*pds).av_dv_y	= (double ***)an_malloc_3D( sx, sy, n, d ) ;

	(*pds).a	= (double ***)an_malloc_3D( sx, sy, n, d ) ;
	(*pds).bij	= (double ***)an_malloc_3D( sx, sy, n, d ) ;
	(*pds).max	= (double ***)an_malloc_3D( sx, sy, n, d ) ;
	(*pds).adif	= (double ***)an_malloc_3D( sx, sy, n, d ) ;

	if (	(*pds).iu==NULL		||
		(*pds).ou==NULL		|| (*pds).nu==NULL	||
		(*pds).ov==NULL		|| (*pds).nv==NULL	||
		(*pds).dv==NULL 	||
		(*pds).av_dv_x==NULL	|| (*pds).av_dv_y==NULL	||
		(*pds).a==NULL		|| (*pds).bij==NULL	||
		(*pds).max==NULL 	|| (*pds).adif==NULL
	) {
		free_mem( ps, *pds ) ;
		return -1 ;
	} else
		return 0 ;
}

int main( argc, argv )
	int argc ;
	char **argv ;
{
	PARAMS ps ;
	DIMS ds ;
	int calc() ;

	if ( argc!=3 ) {
		fprintf( stderr, "usage: %s file file\n", argv[0] ) ;
		return 1 ;
	} else if ( chk_para( argv, &ps )==-1 ) {
		fputs( "check the parameter file\n", stderr ) ;
		return 2 ;
	} else if ( all_mem( ps, &ds )==-1 ) {
		fputs( "cannot allocate memory\n", stderr ) ;
		return 2 ;
	} else if ( calc( ps, ds )==-1 ) {
		free_mem( ps, ds ) ;
		fputs( "cannot calculate", stderr ) ;
	} else
		free_mem( ps, ds ) ;

	return 0 ;
}

